// Programa exemplo para verificadores de preos RS-485 com
// comutadora paralela, utilizando a Wtechlpt.dll
// Utiliza um arquivo TXT para consulta dos produtos.

unit uVerificador;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TfrmVerificadorPrecos = class(TForm)
    edPorta: TEdit;
    edTimeOut: TEdit;
    edMsg1: TEdit;
    edMsg2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btInicia: TButton;
    btFechar: TButton;
    tmPrincipal: TTimer;
    tmMensagem: TTimer;
    edQtdTerm: TEdit;
    Label5: TLabel;
    procedure btFecharClick(Sender: TObject);
    procedure btIniciaClick(Sender: TObject);
    procedure tmPrincipalTimer(Sender: TObject);
    procedure tmMensagemTimer(Sender: TObject);
  private
    { Private declarations }
  public
          // Funes internas
          procedure Gdisplay( str:string );
          procedure GClear();
          procedure Gecho( str:char );
          procedure GPosCursor( linha:integer; coluna:integer );
          procedure Gget( str : string );
          function GtrTecla:boolean;
          procedure Ginicia();
          procedure gAjustaPonto;
          function Pesquisa(Terminal: Integer;Codigo:string): boolean;
  end;

  const  TEXIBE = 3;       // Tempo de apresentao da informao de cdigo lido
         TMSG = 3;         // Tempo de troca das mensagens quando esperando leitura de cdigo. (standby)

var
  frmVerificadorPrecos: TfrmVerificadorPrecos;

  terminal: integer; // Terminal corrente
  NTerminal: integer; // Numero maximo de terminais na rede. Deixar apenas os que existirem
  Arquivo: string; // Arquivo .TXT contendo os produtos cadastrados

  //Vetores criados para controle de cada terminal
  teclado:array[0..31] of string;
  waitkbd:array[0..31] of boolean;
  pikture:array[0..31] of string;
  pospic :array[0..31] of integer;
  estado :array[0..31] of integer;

  troca_tela:array[0..31] of boolean;
  linha1:array[0..31] of string;
  linha2:array[0..31] of string;
  tempo:array[0..31] of integer;
  mensagem:array[0..31] of integer;

  // Declarao de funes contidas na Wtechlpt.dll
  function ConfigLpt(Endereco, Timeout:Word):Boolean; stdcall; external 'WTechLpt.dll';
  procedure Dll_PosCur (Terminal, Lin, Col: Byte); stdcall; external 'WTechLpt.dll';
  procedure Dll_Clear (Terminal:Byte); stdcall; external 'WTechLpt.dll';
  procedure Dll_Echo (Terminal:Byte;Dado:char); stdcall; external 'WTechLpt.dll';
  procedure Dll_Display (Terminal:Byte; Dado:string); stdcall; external 'WTechLpt.dll';
  function Dll_Get(Terminal:Byte):char; stdcall; external 'WTechLpt.dll';
  procedure Dll_Close();stdcall; external 'WTechLpt.dll';

implementation

{$R *.DFM}

// Escreve o caracter correspondente no terminal selecionado
procedure TfrmVerificadorPrecos.Gecho( str:char );
begin
     Dll_Echo(Terminal,str);
end;

//Limpa o display do terminal
procedure TfrmVerificadorPrecos.GClear();
begin
     Dll_Clear(Terminal);
end;

//Posiciona o cursor na linha e coluna desejadas
procedure TfrmVerificadorPrecos.GPosCursor( linha:integer; coluna:integer );
begin
     Dll_PosCur(Terminal,Linha, coluna);
end;

//Coloca mscara no valor digitado
procedure TfrmVerificadorPrecos.Gget( str : string );
begin
     if (waitkbd[terminal]=false) then
     begin
          waitkbd[terminal] := true;
          pospic[terminal]  := 1;
          pikture[terminal] := str;
          teclado[terminal] := '';
     end;
end;

//Inicializa as variveis de controle
procedure TfrmVerificadorPrecos.Ginicia();
var i: integer;
begin
     for  i:=0  to NTerminal - 1 do
     begin
          mensagem[i]:= 1;
          tempo[i]:= 1;
          troca_tela[i]:= false;
          estado[i]:= 0;
     end;

     try
         NTerminal := StrToInt(frmVerificadorPrecos.edQtdTerm.Text);
         if not (NTerminal in [0..31]) then
         ShowMessage('Digite o nmero de terminais entre 0  31.');
     except
         MessageDlg('Digite um valor vlido.',mtError,[mbok],0);
         Exit;
     end;

     ConfigLpt(StrToInt('$' + frmVerificadorPrecos.edPorta.Text) ,StrToInt(frmVerificadorPrecos.edTimeOut.Text));//Configura porta e timeOut
     { ConfigLpt(endereo,timeout)
       endereo -> endereo da porta LPT
       timeout -> A comutadora tem um processador interno que  mais
                  lento que o processador do PC que a controla, por isso  necessrio
                  informar um valor de timeout para que o PC espere um tempo entre o
                  envio de dois comandos para a mesma. Quanto mais rpido o PC maior
                  deve ser esse valor. Se for especificado um valor muito baixo pode
                  haver perda de comandos enviados. Por outro lado se for especificado
                  um valor muito alto, a performance do sistema pode ficar
                  comprometida. Portanto para cada PC deve ser especificado um valor
                  adequado para o timeout. Vide manual da comutadora paralela.
      }
end;

//Testa se a tecla ponto foi pressionada
procedure TfrmVerificadorPrecos.gAjustaPonto;
var
   PosPonto:integer;
   StrDisp:string;
   spPic:integer;
begin
   PosPonto:=1;
   while (copy(Pikture[terminal], PosPonto, 1) <> '.') do
   begin
      PosPonto := PosPonto + 1;
      if PosPonto = length(Pikture[terminal]) then
      begin
         Exit;
      end;
   end;
   if PosPonto = length(Pikture[terminal]) then
   begin
      exit;
   end;
   spPic := PosPonto - 1 - length(Teclado[terminal]);
   StrDisp:='';
   while spPic > 0 do
   begin
      StrDisp := StrDisp + ' ';
      spPic:=spPic - 1;
   end;
   strdisp := strdisp + Teclado[terminal];
   sppic := PosPic[terminal];
   While sppic > 1 do
   begin
      Gecho (chr(8));
      sppic := sppic - 1;
   end;
   PosPic[terminal] := posponto;
   Gdisplay (strdisp);
   Teclado[terminal] := strdisp;
end;

function TfrmVerificadorPrecos.Pesquisa(Terminal: Integer;Codigo:string): boolean;
var arq_produtos: TextFile;
    str, cod, descricao, preco: string;
begin
     result:= false;
     try
         AssignFile(arq_produtos,Arquivo);
         Reset(arq_produtos);
         while not EOF(arq_produtos) do
         begin
              Readln(arq_produtos,str);
              cod:= copy(str,1,13);
              if cod = Codigo then
              begin
                   descricao:= copy(str,15,20);
                   preco:= copy(str,36,6);
                   linha1[terminal]:= trim(descricao);
                   linha2[terminal]:= 'R$ ' + trim(preco);
                   result:= true;
                   break;
              end;
         end;
         CloseFile(arq_produtos);
     except
         Application.MessageBox('Erro ao ler o arquivo de produtos!','Erro',16);
         tmPrincipal.Enabled:= false;
         tmMensagem.Enabled:= false;
         btInicia.Caption := 'Inicia';
     end;
end;

{   Trata tecla que foi pressionada.
    Funcao de tratamento do teclado do terminal.
Pede tecla e faz a consistencia com a picture
solicitada na funcao GGET, aceitando ou rejeitando
o que for digitado no terminal.
    Tambem faz o tratamento do 'DEL' do terminal,
limpando o campo quando tem algum caracter digitado
ou retornando ESC quando nao tinha nada digitado.
    O retorno desta funcao sera:
         false - quando a picture solicitada no
              ultimo gget nao tiver sido digitada, ou seja, a mscara no se
              completou.
         true - quando a picture tiver sido digitada completamente.}
function TfrmVerificadorPrecos.GtrTecla:boolean;
var
   gPict  :string;
   stecla : char;
   tamanho:integer;
begin
   if  (WaitKbd[terminal] = false) then
       begin
            result := false;
            exit;
       end;

   stecla:= Dll_Get(Terminal);
   if  (sTecla = Chr(13)) then //se enter
       begin
            WaitKbd[terminal] := false;
            result := true;
            exit;
       end;
   if sTecla = Chr(127) then // Tecla Del
      begin
         if PosPic[terminal] = 1 then
            begin
                 Teclado[Terminal]:= STecla;
                 WaitKbd[terminal] := false;
                 result         := true;
            end
         else
             begin
                   while pospic[terminal] > 1 do
                  begin
                        Gecho( chr(8) );
                        pospic[terminal]:=pospic[terminal]-1;
                  end;
                  result:=false;
             end;
         exit;
      end;

   if sTecla=Chr(0) then
      begin
           result := false;
           exit;
      end;
   if sTecla = Chr(8) then
   begin
      if PosPic[terminal] > 1 then
      begin
         gpict := copy (Pikture[terminal], pospic[terminal] - 1, 1);
         if (gpict = '/') or (gpict = '.') then
            begin
               pospic[terminal] := pospic[terminal] - 1;
               Gecho( chr(8) );
            end;
         pospic [terminal] := pospic[terminal] - 1;
         Teclado[terminal] := copy (Teclado[terminal], 1, pospic[terminal] - 1);
         Gecho(chr(8));
      end;
      result := false;
      exit;
   end;

   gpict := copy (Pikture[terminal], pospic[terminal], 1);

   if gpict = #3 then
   begin
         if STecla = #3 then // todo peso foi recebido
         begin
                  waitkbd[terminal] := false;
                  result := true;
                  exit;
         end
          else
              begin
                      if (sTecla<>#2)and (sTecla<>#3) then
                      Teclado[terminal] := Teclado[terminal] + sTecla;
              end;
   end;

   if gpict = 'X' then
      begin
         Teclado[terminal] := Teclado[terminal] + sTecla;
         pospic [terminal] := pospic [terminal] + 1;
         gEcho (stecla);
      end
   else if gpict = '9' then // Somente aceitar numeros e "." ou "/" ou "-"
        begin
             if ((sTecla >= '0') and (sTecla <= '9')) or (sTecla = '.')
                         or (sTecla = '/')or (sTecla = '-') then
                begin
                     if sTecla = '.' then begin
                        gAjustaPonto ();
                     end
                else
                    begin
                         Teclado[terminal] := Teclado[terminal] + sTecla;
                         pospic [terminal] := pospic [terminal] + 1;
                         //gEcho(stecla);
                    end;
                end;
        end
   else if gpict = 'A' then // Alfabetico
        begin
             if (sTecla >= 'A') and (sTecla <= 'Z') then
                begin
                     Teclado[terminal] := Teclado[terminal] + sTecla;
                     pospic [terminal] := pospic [terminal] + 1;
                     gEcho(stecla);
                end;
             end
   else if gpict = '*' then // Senha
      begin
             If sTecla in['0'..'9'] Then // caso apenas nmero
             begin
                     Teclado[terminal] := Teclado[terminal] + sTecla;
                     pospic [terminal] := pospic [terminal] + 1;
                     gEcho ('*');
             end;
      end
   else begin
      result := false;
      exit;
   end;
   tamanho := length(Pikture[terminal]) + 1;
   gpict   := copy (Pikture[terminal], pospic[terminal], 1);
   if tamanho = pospic[terminal] then
   begin
      waitkbd[terminal] := false;
      result := true;
   end
   else if gpict = '/' then
   begin
      sTecla := '/';
      pospic[terminal] := pospic[terminal] + 1;
      gEcho  (stecla);
      result := false;
   end
   else if gpict = '.' then
   begin
      sTecla := '.';
      pospic[terminal] := pospic[terminal] + 1;
      gEcho  (stecla);
      result := false;
   end
   else begin
      result := false;
   end;
end;

//Escreve a string correspondente no terminal selecionado
procedure TfrmVerificadorPrecos.Gdisplay( str:string );
begin
     Dll_Display(Terminal,str);
end;

procedure TfrmVerificadorPrecos.btFecharClick(Sender: TObject);
begin
      tmPrincipal.Enabled:= false;
      tmMensagem.Enabled:= false;
      Dll_Close();
      Application.Terminate;
end;

procedure TfrmVerificadorPrecos.btIniciaClick(Sender: TObject);
begin
     if btInicia.Caption = 'Inicia' then
     begin
             Ginicia();
             Arquivo:= GetCurrentDir + '\produtos.txt';
             if not FileExists(Arquivo) then
             begin
                  Application.MessageBox('Arquivo de Produtos no encontrado!','Localizao',48);
                  Exit;
             end;
             tmPrincipal.enabled:=true; //Inicia Timer (Incio do Programa)
             tmMensagem.enabled:=true;
             btInicia.Caption := 'Para';
     end
        else
            begin
                 tmPrincipal.enabled:=false; //Finaliza Timer (Fim Programa)
                 tmMensagem.enabled:=false;
                 btInicia.Caption := 'Inicia';
            end;
end;

//Timer para varredura da rede de Terminais
procedure TfrmVerificadorPrecos.tmPrincipalTimer(Sender: TObject);
var
i:integer;
begin

     for i:=0 to NTerminal - 1 do // Quanto menor o nmero de Terminais a serem varridos na rede,
     begin                        // maior ser o desempenho (rapidez) do sistema.

          Terminal:= i;
          case estado[terminal] of

                // Estado onde  definido o formato da entrada do cdigo
                // XXXXX -> qualquer coisa
                // 99999 -> s numeros
               0: begin
                      Gget('99999999999999'); // 14 digitos= EAN13 + CR
                      estado[terminal]:= 1;
               end;

                // Estado de espera que uma leitura fique completa, ou seja
                // todos os digitos enviados seguidos por um CR ( chr(13) ).
               1: begin
                      If GtrTecla() Then
                      begin
                           // a varivel teclado[terminal] contm o cdigo lido.
                           // Acesse o seu banco de dados e passe as informaes a
                           // serem apresentadas formatadas em 2 linhas de 20 colunas
                           // nas variaveis Linha1[] e Linha2[] conforme abaixo.

                           if Pesquisa(Terminal,teclado[terminal]) = false then
                           begin
                                linha1[terminal]:= '  Produto nao';
                                linha2[terminal]:= '     Cadastrado';
                           end;
                           //linha1[terminal]:= 'Cod: '+teclado[terminal];
                           //linha2[terminal]:= 'Preco item';
                           tempo[terminal]:= TEXIBE;
                           troca_tela[terminal]:= true;
                           estado[terminal]:= 0;
                      end;
               end;

          end;

          if troca_tela[terminal] = true then
          begin
               troca_tela[terminal]:= false;
               Gclear();
               Gdisplay(linha1[terminal]);
               GPosCursor(1,0);
               Gdisplay(linha2[terminal]);
          end;
     end;

end;

// Timer para troca de mensagens
// Verifica se o contador de tempo ( 1segundo ) zerou
// troca a mensagem a ser apresentada
procedure TfrmVerificadorPrecos.tmMensagemTimer(Sender: TObject);
var
i:integer;
begin

     for i:=0 to NTerminal - 1 do
     begin

          if tempo[i] > 1 then
          begin
               dec(tempo[i]);
          end
          else
              begin
                   troca_tela[i]:= true;
                   tempo[i]:= TMSG;
                   if mensagem[i] = 1 then
                   begin
                        linha1[i]:= edMsg1.Text;
                        linha2[i]:= '';
                        mensagem[i]:= 2;
                   end
                   else
                       begin
                            linha1[i]:= '';
                            linha2[i]:= edMsg2.Text;
                            mensagem[i]:= 1;
                       end;
              end;
     end;

end;

end.
